/*
 * File:   vs.c
 * Mp3_02c
 *
 * Created on 2015/05/02, 8:10
 */


void	VS1033RESET(void){
    VS1033COMM(0,0x0004);		// MODE : Soft reset
    delay_cycles(256);          // PCH
    //_delay(256);              // XC8
    
    VS1033COMM(0,0x0000);		// need
    while(!input(MP3_DREQ));	//
	
    VS1033COMM(3,0x9000);		// CLOCKF : Clock multiplier x 3.0 , Multiplier addtion 1.0 x 
    delay_cycles(256);
    //_delay(256);              // XC8
    
    VS1033COMM(11,((uint16_t)VOLUME<<8)|((uint16_t)VOLUME));
    delay_cycles(256);
    //_delay(256);              // XC8
    
}

void    VS1033VOLUME(uint8_t VOLUME){
    VS1033COMM(11,((uint16_t)VOLUME<<8)|((uint16_t)VOLUME));
    //delay_cycles(256);
}

void	VS1033COMM(uint8_t addr, uint16_t arg){
    output_low(MP3_CS);
    VS1033WRITE(2);
    VS1033WRITE(addr);
    VS1033WRITE(arg>>8);
    VS1033WRITE(arg);
    output_high(MP3_CS);
}

void	VS1033WRITE(uint8_t data){
    int16 i;

    for(i=0;i<8;i++)
    {
        if(data & 0x80)
        {
            output_high(MP3_SI);
        }
        else
        {
            output_low(MP3_SI);
        }
        delay_cycles(4);
        //_delay(4);              // XC8
        output_high(MP3_SCLK);
        delay_cycles(4);
        //_delay(4);              // XC8
        data<<=1;
        output_low(MP3_SCLK);
        delay_cycles(4);
        //_delay(4);              // XC8
    }
    output_high(MP3_SI);
    delay_cycles(4);
    //_delay(4);              // XC8
}

void
VS1033SENDBYTE(uint8_t data){
    int     c;

    output_high(MP3_BSYNC);
    for(c=0; c<8; c++){
        if(data & 0x80){
            output_high(MP3_SI);
        } else {
            output_low(MP3_SI);
        }
        output_high(MP3_DCLK);
        data <<= 1;
        output_low(MP3_DCLK);
        output_low(MP3_BSYNC);
    }
}

//typedef signed UINT (*_Fwdfun)(const FFBYTE * buff, UINT btf);
//VS1033SENDDATA(uint8_t DATA[], uint16_t br){

// f_forward(FatFs) Callback function
UINT
VS1033SENDDATA(const FFBYTE *DATA, UINT br){
    int16       i;
    uint8_t     data;

    if (br == 0) return (1);

    for (i=0; i<br; i++){
        data = *(DATA + i);
        VS1033SENDBYTE(data);
    }

    return (br);
}

/*
UINT
VS1033SENDDATA(const FFBYTE *DATA, UINT br){
    int16       i, j, sendbyte;
    uint8_t     data;
    int16       idxPlay;

    idxPlay = 0;

    for (j=0; j<16; j++){
        while(!(input(MP3_DREQ)));

        if (br >= SEND_SIZE) sendbyte = SEND_SIZE;
        else sendbyte = br;
        for (i=0; i<sendbyte; i++){
            data = *(DATA + idxPlay + i);
            VS1033SENDBYTE(data);
        }

        if (sendbyte < SEND_SIZE){
            break;
        }
        idxPlay += sendbyte;
        br -= sendbyte;
    }

    return (br);
}
*/


void
VS1033SENDZEROS(uint16_t cnt){
    uint16_t    i;

    for (i=0; i<cnt; i++){
        while(!(input(MP3_DREQ)));

        VS1033SENDBYTE(0);
    }
}
